
#include <fstream>
#include <cmath>

const long double eps = 1E-8;
const int precision = 15;

template <typename T>
inline T len(T x, T y, T z) { return std::sqrt(x*x + y*y + z*z); }
template <typename T>
inline T sqr(T t) { return t*t; }

template <typename T>
void norm (T& a, T& b, T& c)
{
  T t = len(a, b, c);
  a /= t; b /= t; c /= t;
}

int main(int argc, char** argv)
{
  long double tx, ty, tz, ta, tb, tc, r1, r2, sx, sy, sz, pa, pb, pc, t;
  std::fstream input("input.txt", std::ios_base::in);
  std::fstream output("output.txt", std::ios_base::out);

  input >> tx >> ty >> tz >> ta >> tb >> tc >> r1 >> r2 >> sx >> sy >> sz;

  sx -= tx; sy -= ty; sz -= tz;

  norm(ta, tb, tc);

  if (len(tb*sz - tc*sy, -ta*sz + tc*sx, ta*sy - tb*sx) > eps) 
  {  
    pa = sx; pb = sy; pc = sz; 
  }
  else
    if (abs(ta) < eps) 
    { 
      pa = 1; pb = 0; pc = 0; 
    }
    else 
    { 
      pa = 0; pb = 1; pc = 1;
    }

  t = pa*ta + pb*tb + pc*tc;
  pa -= t*ta; pb -= t*tb; pc -= t*tc;

  norm(pa, pb, pc);
  pa *= r1; pb *= r1; pc *= r1;

  sx -= pa; sy -= pb; sz -= pc;
  norm(sx, sy, sz);
  
  output.precision(precision);
  output << tx + pa + sx * r2 << " " << ty + pb + sy * r2 << " " << tz + pc + sz * r2;

  return 0;
}